open DomAbsValue
open DomAcc
open DomBasic
open DomBridge
open DomItv
open DomMap
open DomSet
open DomType
open List0
open MapInterface
open SetAVLInstance
open SetInterface

type memT = (locT, valueT) dict withtop

(** val memT_setoid : memT setoid **)

let memT_setoid =
  withtop_setoid
    (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)

(** val memT_setoidDec : memT setoidDec **)

let memT_setoidDec =
  withtop_setoidDec
    (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_setoidDec locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot
      (pair_setoidDec
        (pair_setoid (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)))
        (withtop_setoid
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot))
        (pair_setoidDec (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (option_setoidDec itvT'_setoid itvT'_setoidDec)
          (withtop_setoidDec
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_setoidDec locT_setoid locT_poset locT_setoidDec
              locT_posetDec)))
        (withtop_setoidDec
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot)
          (map_setoidDec positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot
            (pair_setoidDec
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid)
              (pair_setoidDec (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_setoidDec itvT'_setoid itvT'_setoidDec))
              (option_setoidDec itvT'_setoid itvT'_setoidDec))))))

(** val memT_poset : memT poset **)

let memT_poset =
  withtop_poset
    (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)

(** val memT_posetDec : memT posetDec **)

let memT_posetDec =
  withtop_posetDec
    (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_setoidDec locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot
      (pair_setoidDec
        (pair_setoid (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)))
        (withtop_setoid
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot))
        (pair_setoidDec (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (option_setoidDec itvT'_setoid itvT'_setoidDec)
          (withtop_setoidDec
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_setoidDec locT_setoid locT_poset locT_setoidDec
              locT_posetDec)))
        (withtop_setoidDec
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot)
          (map_setoidDec positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot
            (pair_setoidDec
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid)
              (pair_setoidDec (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_setoidDec itvT'_setoid itvT'_setoidDec))
              (option_setoidDec itvT'_setoid itvT'_setoidDec))))))
    (map_posetDec locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot
      (pair_setoidDec
        (pair_setoid (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)))
        (withtop_setoid
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot))
        (pair_setoidDec (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (option_setoidDec itvT'_setoid itvT'_setoidDec)
          (withtop_setoidDec
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_setoidDec locT_setoid locT_poset locT_setoidDec
              locT_posetDec)))
        (withtop_setoidDec
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot)
          (map_setoidDec positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot
            (pair_setoidDec
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid)
              (pair_setoidDec (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_setoidDec itvT'_setoid itvT'_setoidDec))
              (option_setoidDec itvT'_setoid itvT'_setoidDec)))))
      (pair_posetDec_pointwise
        (pair_setoid (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)))
        (withtop_setoid
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot))
        (pair_poset_pointwise (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (option_poset itvT'_setoid itvT'_poset)
          (withtop_poset
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)))
        arrvT_poset
        (pair_setoidDec (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (option_setoidDec itvT'_setoid itvT'_setoidDec)
          (withtop_setoidDec
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_setoidDec locT_setoid locT_poset locT_setoidDec
              locT_posetDec)))
        (withtop_setoidDec
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot)
          (map_setoidDec positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot
            (pair_setoidDec
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid)
              (pair_setoidDec (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_setoidDec itvT'_setoid itvT'_setoidDec))
              (option_setoidDec itvT'_setoid itvT'_setoidDec))))
        (pair_posetDec_pointwise (option_setoid itvT'_setoid)
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (option_poset itvT'_setoid itvT'_poset)
          (withtop_poset
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (option_setoidDec itvT'_setoid itvT'_setoidDec)
          (withtop_setoidDec
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_setoidDec locT_setoid locT_poset locT_setoidDec
              locT_posetDec))
          (option_posetDec itvT'_setoid itvT'_poset itvT'_setoidDec
            itvT'_posetDec)
          (withtop_posetDec
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_setoidDec locT_setoid locT_poset locT_setoidDec
              locT_posetDec)
            (set_posetDec locT_setoid locT_poset locT_setoidDec
              locT_posetDec)))
        (withtop_posetDec
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot)
          (map_poset positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot)
          (map_setoidDec positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot
            (pair_setoidDec
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid)
              (pair_setoidDec (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_setoidDec itvT'_setoid itvT'_setoidDec))
              (option_setoidDec itvT'_setoid itvT'_setoidDec)))
          (map_posetDec positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot
            (pair_setoidDec
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid)
              (pair_setoidDec (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_setoidDec itvT'_setoid itvT'_setoidDec))
              (option_setoidDec itvT'_setoid itvT'_setoidDec))
            (pair_posetDec_pointwise
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid)
              osT_poset (option_poset itvT'_setoid itvT'_poset)
              (pair_setoidDec (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_setoidDec itvT'_setoid itvT'_setoidDec))
              (option_setoidDec itvT'_setoid itvT'_setoidDec)
              (pair_posetDec_pointwise (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)
                (option_poset itvT'_setoid itvT'_poset)
                (option_poset itvT'_setoid itvT'_poset)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_setoidDec itvT'_setoid itvT'_setoidDec)
                (option_posetDec itvT'_setoid itvT'_poset itvT'_setoidDec
                  itvT'_posetDec)
                (option_posetDec itvT'_setoid itvT'_poset itvT'_setoidDec
                  itvT'_posetDec))
              (option_posetDec itvT'_setoid itvT'_poset itvT'_setoidDec
                itvT'_posetDec))))))

(** val memT_hasTop : memT hasTop **)

let memT_hasTop =
  withtop_hasTop
    (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)

(** val memT_maplike : (locT, valueT, memT) maplike **)

let memT_maplike =
  withtop_maplike
    (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot) locT_setoid locT_setoidDec
    valueT_setoid valueT_poset valueT_hasTop
    (map_maplike locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)

(** val memT_restricting_maplike :
    (locT, valueT, memT) restricting_maplike **)

let memT_restricting_maplike =
  withtop_restricting_maplike
    (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot) locT_setoid locT_setoidDec
    valueT_setoid valueT_poset valueT_hasTop
    (map_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_maplike locT_setoid locT_poset locT_setoidDec locT_posetDec
      valueT_setoid valueT_poset valueT_hasBot)
    (map_restricting_maplike locT_setoid locT_poset locT_setoidDec
      locT_posetDec valueT_setoid valueT_poset valueT_hasBot)

(** val memory_lookup : locsT -> memT -> valueT **)

let memory_lookup ls mem =
  match ls with
  | Elt ls' ->
    fold
      (order_OrderedType locT_setoid locT_poset locT_setoidDec locT_posetDec)
      (coq_SetAVL_FSet
        (order_OrderedType locT_setoid locT_poset locT_setoidDec
          locT_posetDec)) (fun loc val0 ->
      join valueT_setoid valueT_poset valueT_hasJoin
        (memT_maplike.mlookup loc mem) val0) ls'
      (bot valueT_setoid valueT_poset valueT_hasBot)
  | Top -> top valueT_setoid valueT_poset valueT_hasTop

(** val memory_update : accT -> locsT -> valueT -> memT -> memT **)

let memory_update acc ls value = function
| Elt mem' ->
  (match ls with
   | Elt ls' ->
     Elt
       (let ls'' =
          (coq_SetAVL_FSet
            (order_OrderedType locT_setoid locT_poset locT_setoidDec
              locT_posetDec)).elements ls'
        in
        match ls'' with
        | [] ->
          fold_left (fun mem'0 loc ->
            (map_maplike locT_setoid locT_poset locT_setoidDec locT_posetDec
              valueT_setoid valueT_poset valueT_hasBot).madd loc
              (join valueT_setoid valueT_poset valueT_hasJoin
                ((map_maplike locT_setoid locT_poset locT_setoidDec
                   locT_posetDec valueT_setoid valueT_poset valueT_hasBot).mlookup
                  loc mem'0) value) mem'0) ls'' mem'
        | loc :: l ->
          (match l with
           | [] ->
             if is_strong acc loc
             then (map_maplike locT_setoid locT_poset locT_setoidDec
                    locT_posetDec valueT_setoid valueT_poset valueT_hasBot).madd
                    loc value mem'
             else (map_maplike locT_setoid locT_poset locT_setoidDec
                    locT_posetDec valueT_setoid valueT_poset valueT_hasBot).madd
                    loc
                    (join valueT_setoid valueT_poset valueT_hasJoin
                      ((map_maplike locT_setoid locT_poset locT_setoidDec
                         locT_posetDec valueT_setoid valueT_poset
                         valueT_hasBot).mlookup loc mem') value) mem'
           | l0 :: l1 ->
             fold_left (fun mem'0 loc0 ->
               (map_maplike locT_setoid locT_poset locT_setoidDec
                 locT_posetDec valueT_setoid valueT_poset valueT_hasBot).madd
                 loc0
                 (join valueT_setoid valueT_poset valueT_hasJoin
                   ((map_maplike locT_setoid locT_poset locT_setoidDec
                      locT_posetDec valueT_setoid valueT_poset valueT_hasBot).mlookup
                     loc0 mem'0) value) mem'0) ls'' mem'))
   | Top -> top memT_setoid memT_poset memT_hasTop)
| Top -> top memT_setoid memT_poset memT_hasTop

