open DomAbsValue
open DomAcc
open DomBasic
open DomBridge
open DomItv
open DomMap
open DomSet
open DomType
open List0
open MapInterface
open SetAVLInstance
open SetInterface

type memT = (locT, valueT) dict withtop

val memT_setoid : memT setoid

val memT_setoidDec : memT setoidDec

val memT_poset : memT poset

val memT_posetDec : memT posetDec

val memT_hasTop : memT hasTop

val memT_maplike : (locT, valueT, memT) maplike

val memT_restricting_maplike : (locT, valueT, memT) restricting_maplike

val memory_lookup : locsT -> memT -> valueT

val memory_update : accT -> locsT -> valueT -> memT -> memT

