(** val lift1 : ('a1 -> 'a1) -> 'a1 option -> 'a1 option **)

let lift1 op = function
| Some val' -> Some (op val')
| None -> None

(** val lift2 :
    ('a1 -> 'a1 -> 'a1) -> 'a1 option -> 'a1 option -> 'a1 option **)

let lift2 op lhs rhs =
  match lhs with
  | Some lhs' ->
    (match rhs with
     | Some rhs' -> Some (op lhs' rhs')
     | None -> None)
  | None -> None

