open OrderedType

type __ = Obj.t

type 'key coq_FMap = { empty : (__ -> __); is_empty : (__ -> __ -> bool);
                       mem : (__ -> 'key -> __ -> bool);
                       add : (__ -> 'key -> __ -> __ -> __);
                       find : (__ -> 'key -> __ -> __ option);
                       remove : (__ -> 'key -> __ -> __);
                       equal : (__ -> (__ -> __ -> bool) -> __ -> __ -> bool);
                       map : (__ -> __ -> (__ -> __) -> __ -> __);
                       mapi : (__ -> __ -> ('key -> __ -> __) -> __ -> __);
                       map2 : (__ -> __ -> __ -> (__ option -> __ option ->
                              __ option) -> __ -> __ -> __);
                       fold : (__ -> __ -> ('key -> __ -> __ -> __) -> __ ->
                              __ -> __); cardinal : (__ -> __ -> int);
                       elements : (__ -> __ -> ('key * __) list);
                       insert : (__ -> 'key -> __ -> (__ -> __) -> __ -> __);
                       adjust : (__ -> 'key -> (__ -> __) -> __ -> __);
                       coq_FMap_OrderedType : (__ -> __ coq_OrderedType -> __
                                              coq_OrderedType) }

type ('key, 'elt) dict = __

val empty : 'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict

val is_empty : 'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> bool

val mem :
  'a1 coq_OrderedType -> 'a1 coq_FMap -> 'a1 -> ('a1, 'a2) dict -> bool

val add :
  'a1 coq_OrderedType -> 'a1 coq_FMap -> 'a1 -> 'a2 -> ('a1, 'a2) dict ->
  ('a1, 'a2) dict

val find :
  'a1 coq_OrderedType -> 'a1 coq_FMap -> 'a1 -> ('a1, 'a2) dict -> 'a2 option

val remove :
  'a1 coq_OrderedType -> 'a1 coq_FMap -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2)
  dict

val map :
  'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> 'a3) -> ('a1, 'a2) dict ->
  ('a1, 'a3) dict

val map2 :
  'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 option -> 'a3 option -> 'a4
  option) -> ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1, 'a4) dict

val fold :
  'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1,
  'a2) dict -> 'a3 -> 'a3

val cardinal : 'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> int

val elements :
  'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2) list

