open Datatypes

type 'a coq_OrderedType =
  'a -> 'a -> comparison
  (* singleton inductive, whose constructor was Build_OrderedType *)

(** val _cmp : 'a1 coq_OrderedType -> 'a1 -> 'a1 -> comparison **)

let _cmp orderedType =
  orderedType

(** val compare : 'a1 coq_OrderedType -> 'a1 -> 'a1 -> comparison **)

let compare h =
  _cmp h

(** val is_compare :
    'a1 coq_OrderedType -> 'a1 -> 'a1 -> comparison -> bool **)

let is_compare h x y c =
  match compare h x y with
  | Eq ->
    (match c with
     | Eq -> true
     | _ -> false)
  | Lt ->
    (match c with
     | Lt -> true
     | _ -> false)
  | Gt ->
    (match c with
     | Gt -> true
     | _ -> false)

type 'a coq_SpecificOrderedType =
  'a -> 'a -> comparison
  (* singleton inductive, whose constructor was Build_SpecificOrderedType *)

module KeyOrderedType = 
 struct 
  
 end

