open OrderedType

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type 'a coq_FSet = { empty : __; is_empty : (__ -> bool);
                     mem : ('a -> __ -> bool); add : ('a -> __ -> __);
                     singleton : ('a -> __); remove : ('a -> __ -> __);
                     union : (__ -> __ -> __); inter : (__ -> __ -> __);
                     diff : (__ -> __ -> __); equal : (__ -> __ -> bool);
                     subset : (__ -> __ -> bool);
                     fold : (__ -> ('a -> __ -> __) -> __ -> __ -> __);
                     for_all : (('a -> bool) -> __ -> bool);
                     exists_ : (('a -> bool) -> __ -> bool);
                     filter : (('a -> bool) -> __ -> __);
                     partition : (('a -> bool) -> __ -> __ * __);
                     cardinal : (__ -> int); elements : (__ -> 'a list);
                     choose : (__ -> 'a option); min_elt : (__ -> 'a option);
                     max_elt : (__ -> 'a option);
                     coq_FSet_OrderedType : __ coq_SpecificOrderedType }

type 'a set = __

(** val empty : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set **)

let empty _ x = x.empty

(** val mem :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 -> 'a1 set -> bool **)

let mem _ x = x.mem

(** val add :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 -> 'a1 set -> 'a1 set **)

let add _ x = x.add

(** val singleton : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 -> 'a1 set **)

let singleton _ x = x.singleton

(** val remove :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 -> 'a1 set -> 'a1 set **)

let remove _ x = x.remove

(** val union :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 set -> 'a1 set **)

let union _ x = x.union

(** val inter :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 set -> 'a1 set **)

let inter _ x = x.inter

(** val equal :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 set -> bool **)

let equal _ x = x.equal

(** val subset :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 set -> bool **)

let subset _ x = x.subset

(** val fold :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> ('a1 -> 'a2 -> 'a2) -> 'a1 set ->
    'a2 -> 'a2 **)

let fold h fSet x x0 x1 =
  let { empty = empty0; is_empty = is_empty0; mem = mem0; add = add0;
    singleton = singleton0; remove = remove0; union = union0; inter = inter0;
    diff = diff0; equal = equal0; subset = subset0; fold = fold0; for_all =
    for_all0; exists_ = exists_0; filter = filter0; partition = partition0;
    cardinal = cardinal0; elements = elements0; choose = choose0; min_elt =
    min_elt0; max_elt = max_elt0; coq_FSet_OrderedType = fSet_OrderedType } =
    fSet
  in
  Obj.magic fold0 __ x x0 x1

(** val for_all :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> ('a1 -> bool) -> 'a1 set -> bool **)

let for_all _ x = x.for_all

(** val elements :
    'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 list **)

let elements _ x = x.elements

