open MapFacts
open MapInterface
open OrderedType

type __ = Obj.t

module MF : 
 sig 
  module K : 
   sig 
    
   end
  
  val eqb : 'a1 coq_OrderedType -> 'a1 -> 'a1 -> bool
  
  val coq_In_dec :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> 'a1 -> bool
  
  val option_map : ('a1 -> 'a2) -> 'a1 option -> 'a2 option
  
  val eqb_dec : 'a1 coq_OrderedType -> 'a1 -> 'a1 -> bool
  
  val of_list :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 * 'a2) list -> ('a1, 'a2)
    dict
  
  val to_list :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2)
    list
  
  val fold_rec :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> 'a3
    -> ('a1, 'a2) dict -> (('a1, 'a2) dict -> __ -> 'a4) -> ('a1 -> 'a2 ->
    'a3 -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> __ -> __ -> 'a4 ->
    'a4) -> 'a4
  
  val fold_rec_bis :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> 'a3
    -> ('a1, 'a2) dict -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> __ ->
    'a4 -> 'a4) -> 'a4 -> ('a1 -> 'a2 -> 'a3 -> ('a1, 'a2) dict -> __ -> __
    -> 'a4 -> 'a4) -> 'a4
  
  val fold_rec_nodep :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> 'a3
    -> ('a1, 'a2) dict -> 'a4 -> ('a1 -> 'a2 -> 'a3 -> __ -> 'a4 -> 'a4) ->
    'a4
  
  val fold_rec_weak :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> 'a3
    -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> __ -> 'a4 -> 'a4) -> 'a4
    -> ('a1 -> 'a2 -> 'a3 -> ('a1, 'a2) dict -> __ -> 'a4 -> 'a4) -> ('a1,
    'a2) dict -> 'a4
  
  val fold_rel :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1
    -> 'a2 -> 'a4 -> 'a4) -> 'a3 -> 'a4 -> ('a1, 'a2) dict -> 'a5 -> ('a1 ->
    'a2 -> 'a3 -> 'a4 -> __ -> 'a5 -> 'a5) -> 'a5
  
  val map_induction :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> __ -> __ ->
    'a3) -> ('a1, 'a2) dict -> 'a3
  
  val map_induction_bis :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> (('a1, 'a2) dict -> ('a1, 'a2)
    dict -> __ -> 'a3 -> 'a3) -> 'a3 -> ('a1 -> 'a2 -> ('a1, 'a2) dict -> __
    -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
  
  val cardinal_inv_2 :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> int ->
    ('a1 * 'a2)
  
  val cardinal_inv_2b :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2)
  
  val filter :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> bool) -> ('a1, 'a2)
    dict -> ('a1, 'a2) dict
  
  val for_all :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> bool) -> ('a1, 'a2)
    dict -> bool
  
  val exists_ :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> bool) -> ('a1, 'a2)
    dict -> bool
  
  val partition :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> bool) -> ('a1, 'a2)
    dict -> ('a1, 'a2) dict * ('a1, 'a2) dict
  
  val update :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict
  
  val restrict :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict
  
  val diff :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict
  
  val coq_Partition_In :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict -> 'a1 -> bool
  
  val update_dec :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> 'a1 -> 'a2 -> bool
  
  val filter_dom :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> bool) -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict
  
  val filter_range :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> bool) -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict
  
  val for_all_dom :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> bool) -> ('a1, 'a2) dict
    -> bool
  
  val for_all_range :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> bool) -> ('a1, 'a2) dict
    -> bool
  
  val exists_dom :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> bool) -> ('a1, 'a2) dict
    -> bool
  
  val exists_range :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> bool) -> ('a1, 'a2) dict
    -> bool
  
  val partition_dom :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> bool) -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict * ('a1, 'a2) dict
  
  val partition_range :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> bool) -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict * ('a1, 'a2) dict
  
  val gtb : 'a1 coq_OrderedType -> ('a1 * 'a2) -> ('a1 * 'a2) -> bool
  
  val leb : 'a1 coq_OrderedType -> ('a1 * 'a2) -> ('a1 * 'a2) -> bool
  
  val elements_lt :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 * 'a2) -> ('a1, 'a2) dict ->
    ('a1 * 'a2) list
  
  val elements_ge :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 * 'a2) -> ('a1, 'a2) dict ->
    ('a1 * 'a2) list
  
  val max_elt_aux : ('a1 * 'a2) list -> ('a1 * 'a2) option
  
  val max_elt :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2)
    option
  
  val min_elt :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2)
    option
  
  val map_induction_max :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> __ -> __ ->
    'a3) -> ('a1, 'a2) dict -> 'a3
  
  val map_induction_min :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> __ -> __ ->
    'a3) -> ('a1, 'a2) dict -> 'a3
 end

