open DomAbsMem
open DomAbsValue
open DomAcc
open DomBasic
open DomBridge
open DomMap
open DomSet
open DomType
open List0
open SemAbsBlock
open SetAVLInstance
open SetInterface
open Syntax

val acc_correct_callfroms_blk : accT -> fidT -> bidT -> cmdT -> bool

val acc_correct_callfroms_func : accT -> fidT -> funcT -> bool

val acc_correct_acclocs_var : (int, string) PMap.t -> accT -> fidT -> varT -> memT -> bool

val acc_correct_acclocs_site : accT -> fidT -> allocT -> memT -> bool

val acc_correct_acclocs_expr : (int, string) PMap.t -> accT -> fidT -> exprT -> memT -> bool

val acc_correct_acclocs_lv : (int, string) PMap.t -> accT -> fidT -> lv -> memT -> bool

val acc_correct_acclocs_exprs : (int, string) PMap.t -> accT -> fidT -> exprT list -> memT -> bool

val acc_correct_acclocs_libcall_args :
  accT -> fidT -> exprT list -> memT -> bool

val acc_correct_acclocs_instr : (int, string) PMap.t -> accT -> fidT -> instrT -> memT -> bool

val acc_correct_acclocs_instrs : (int, string) PMap.t -> accT -> fidT -> instrT list -> memT -> bool

val acc_correct_acclocs_tmn : (int, string) PMap.t -> accT -> fidT -> tmnT -> memT -> bool
