open OrderedType

type __ = Obj.t

type 'a coq_FSet = { empty : __; is_empty : (__ -> bool);
                     mem : ('a -> __ -> bool); add : ('a -> __ -> __);
                     singleton : ('a -> __); remove : ('a -> __ -> __);
                     union : (__ -> __ -> __); inter : (__ -> __ -> __);
                     diff : (__ -> __ -> __); equal : (__ -> __ -> bool);
                     subset : (__ -> __ -> bool);
                     fold : (__ -> ('a -> __ -> __) -> __ -> __ -> __);
                     for_all : (('a -> bool) -> __ -> bool);
                     exists_ : (('a -> bool) -> __ -> bool);
                     filter : (('a -> bool) -> __ -> __);
                     partition : (('a -> bool) -> __ -> __ * __);
                     cardinal : (__ -> int); elements : (__ -> 'a list);
                     choose : (__ -> 'a option); min_elt : (__ -> 'a option);
                     max_elt : (__ -> 'a option);
                     coq_FSet_OrderedType : __ coq_SpecificOrderedType }

type 'a set = __

val empty : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set

val mem : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 -> 'a1 set -> bool

val add : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 -> 'a1 set -> 'a1 set

val singleton : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 -> 'a1 set

val remove : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 -> 'a1 set -> 'a1 set

val union :
  'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 set -> 'a1 set

val inter :
  'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 set -> 'a1 set

val equal : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 set -> bool

val subset :
  'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 set -> bool

val fold :
  'a1 coq_OrderedType -> 'a1 coq_FSet -> ('a1 -> 'a2 -> 'a2) -> 'a1 set ->
  'a2 -> 'a2

val for_all :
  'a1 coq_OrderedType -> 'a1 coq_FSet -> ('a1 -> bool) -> 'a1 set -> bool

val elements : 'a1 coq_OrderedType -> 'a1 coq_FSet -> 'a1 set -> 'a1 list

